SystemOrganization addCategory: #'Magritte-ComponentDecoration'!

!MADescriptionComponent class methodsFor: '*magritte-componentdecoration-override' stamp: 'kph 12/8/2007 22:49'!
memento: aMemento description: aDescription parent: aComponent
	^ self new
		setMemento: aMemento;
		setDescription: aDescription;
		setParent: aComponent;
		addDecorationClasses: aDescription decorationClasses;
		yourself! !

!MAContainer methodsFor: '*magritte-componentdecoration' stamp: 'kph 8/14/2007 02:21'!
atLabel: aLabel
	^ self detect: [ :desc | desc label = aLabel ]! !

MAComponentDecoration subclass: #MAAnnotationDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-ComponentDecoration'!

!MAAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 19:24'!
postAnnotation

	^ self component description propertyAt: #postAnnotation ifAbsent: nil! !

!MAAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 19:25'!
preAnnotation

	^ self component description propertyAt: #preAnnotation ifAbsent: nil! !

!MAAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 19:31'!
renderAnnotation: text on: html

	text ifNotNil: [ html html: text ]! !

!MAAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 19:28'!
renderContentOn: html 

		   self 
				renderAnnotation: self preAnnotation on: html;				
			   	renderOwnerOn: html;
			 	renderAnnotation: self postAnnotation on: html ! !

MAAnnotationDecoration subclass: #PRAnnotationDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-ComponentDecoration'!

!PRAnnotationDecoration methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 03:29'!
renderAnnotation: text on: html

	| context | 
	
	text isEmptyOrNil ifTrue: [ ^nil ].
	
	context := PRCurrentContext value.
 
	context renderer
		continue: ((PRDocumentParser parse: text) owner: context structure)
		in: self
		on: html;
		yourself! !

!MAComponentDecoration methodsFor: '*magritte-componentdecoration' stamp: 'kph 8/11/2007 20:24'!
addTo: component

	component addDecoration: self.
	
	^ component! !

!MADescription class methodsFor: '*magritte-componentdecoration' stamp: 'kph 8/11/2007 14:21'!
defaultDecorationClasses

	^ #()! !

!MADescription methodsFor: '*magritte-componentdecoration' stamp: 'kph 8/11/2007 14:20'!
decorationClasses
	^ self propertyAt: #decorationClasses ifAbsent: [ self class defaultDecorationClasses ]! !

!MADescription methodsFor: '*magritte-componentdecoration' stamp: 'kph 8/11/2007 14:46'!
decorationClasses: aClass
	^ self propertyAt: #decorationClasses put: aClass! !
